import { Inject, Injectable } from "@angular/core";
import { Observable } from "rxjs/Observable";
import { Http, Headers } from "@angular/http";
import ITodo from "../../../shared/todo-dto";

import "rxjs/add/operator/map";

@Injectable()
export class TodoService {
  static ENDPOINT = "http://localhost:3301/api/todos/:id";

  constructor(private http: Http) { }

  getAll():Observable<ITodo[]> {
    return this.http
               .get(TodoService.ENDPOINT.replace(":id", ""))
               .map((r) => r.json());
  }

  add(message:string):Observable<ITodo> {
    let messageStringified = JSON.stringify({todoMessage: message});

    let headers = new Headers();

    headers.append("Content-Type", "application/json");

    return this.http
               .post(TodoService.ENDPOINT.replace(":id", ""), messageStringified, {headers})
               .map((r) => r.json());
  }

  remove(id: string):Observable<any> {
    return this.http
               .delete(TodoService.ENDPOINT.replace(":id", id));
  }
}
